

-- UPDATE 11.1.1/V11.1.1.20171114__new_annotators.sql

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.TairAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.TairAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.CazyAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.CazyAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.BrendaAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.BrendaAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.StitchAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.StitchAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.StringAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.StringAnnotator');



-- UPDATE 11.1.1/V11.1.1.20180626__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.1.2/V11.1.2.20180704__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.1.3/V11.1.3.20180723__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170713__add_PdbAnnotator.sql

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.PdbAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.PdbAnnotator');

-- UPDATE 12.0.0~alpha.0/V12.0.0.20170720__create_uniprot_table.sql

CREATE SEQUENCE uniprot_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

-- 1:N mapping between element and its uniprot mappings, each of which is then used to map (PDB) structures to it
CREATE TABLE uniprot_table
(
  iddb integer NOT NULL DEFAULT nextval('uniprot_table_iddb_seq'::regclass),
  element_id integer NOT NULL,  
  uniprot_id character varying(255) NOT NULL,
  CONSTRAINT uniprot_pkey PRIMARY KEY (iddb),
  CONSTRAINT uniprot_element_fk FOREIGN KEY (element_id)
      REFERENCES public.element_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);


CREATE SEQUENCE structure_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

/*
based on https://www.ebi.ac.uk/pdbe/api/doc/sifts.html best_structures API

		pdb_id: the PDB ID which maps to the UniProt ID
                chain_id: the specific chain of the PDB which maps to the UniProt ID
                coverage: the percent coverage of the entire UniProt sequence
                resolution: the resolution of the structure
                start: the structure residue number which maps to the start of the mapped sequence
                end: the structure residue number which maps to the end of the mapped sequence
                unp_start: the sequence residue number which maps to the structure start
                unp_end: the sequence residue number which maps to the structure end
                experimental_method: type of experiment used to determine structure
                tax_id: taxonomic ID of the protein's original organism
*/
CREATE TABLE structure_table
(
  iddb integer NOT NULL DEFAULT nextval('structure_table_iddb_seq'::regclass),
  uniprot_id integer NOT NULL,
  pdb_id character varying(255) NOT NULL, --should be character(4), but to be on the safe side...
  chain_id character varying(255) NOT NULL, --should be char(1), but for example 5T0C has has chains AK and BK
  struct_start integer,
  struct_end integer,
  unp_start integer,
  unp_end integer,  
  experimental_method character varying(255),
  coverage double precision,
  resolution double precision,
  tax_id integer,
  CONSTRAINT structure_pkey PRIMARY KEY (iddb),
  CONSTRAINT structure_uniprot_fk FOREIGN KEY (uniprot_id)
      REFERENCES public.uniprot_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);




-- UPDATE 12.0.0~alpha.0/V12.0.0.20170808__version_moved_from_model_into_project.sql

-- version moved from model into project
alter table project_table add column version character varying default '';
update project_table set version = model_table.mapversion from model_table where project_table.iddb = model_table.project_iddb;
alter table model_table drop column mapversion;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170809__images_moved_to_project.sql

-- images moved to project
alter table overview_image_table add column project_iddb integer;
update overview_image_table set project_iddb = model_table.project_iddb from model_table where model_table.iddb = overview_image_table.model_iddb;
delete from overview_image_table where project_iddb is null;
alter table overview_image_table drop column model_iddb;

-- project file moved to downloaded files
alter table project_table add column file_entry_iddb integer;
DO $$ 
DECLARE 
	project 	RECORD;
	last_id 	INT;
BEGIN
  FOR project IN SELECT * FROM project_table where inputData is not null LOOP
	insert into file_entry (filecontent, file_type_db, originalfilename) values
	  (project.inputdata, 'UPLOADED_FILE_ENTRY',project.inputfilename) returning iddb into last_id;
	
  	update project_table set file_entry_iddb = last_id where iddb = project.iddb ;
  	RAISE NOTICE 'Calling cs_create_job(%, %)', project.iddb, last_id ;
  END LOOP;
END $$;

alter table project_table drop column inputdata;
alter table project_table drop column inputfilename;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170814__move_notify_email_from_model_into_project.sql

-- notify email from model into project
alter table project_table add column notifyemail character varying default '';
update project_table set notifyemail = model_table.notifyemail from model_table where project_table.iddb = model_table.project_iddb;
alter table model_table drop column notifyemail;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170822__remove_unnecessery_privileges.sql

--unnecessery privileges removed
delete from privilege_table where type='DRUG_TARGETING_ADVANCED_VIEW_PROJECT' ;
delete from privilege_table where type='EDIT_MISSING_CONNECTIONS_PROJECT' ;

-- UPDATE 12.0.0~alpha.0/V12.0.0.20170829__add_user_prferences_for_uploading_map.sql

--user prferences for uploading map
alter table user_annotation_schema_table add column annotatemodel boolean default false;
alter table user_annotation_schema_table add column autoresizemap boolean default true;
alter table user_annotation_schema_table add column cachedata boolean default true;
alter table user_annotation_schema_table add column semanticzooming boolean default false;
alter table class_required_annotation_table RENAME column requireatlestoneannotation to requireatleastoneannotation;

-- rename config annotation class name
update class_annotator_table set classname ='lcsb.mapviewer.model.map.BioEntity' where classname ='lcsb.mapviewer.model.map.AnnotatedObject';
update class_required_annotation_table set classname ='lcsb.mapviewer.model.map.BioEntity' where classname ='lcsb.mapviewer.model.map.AnnotatedObject';
update class_valid_annotation_table set classname ='lcsb.mapviewer.model.map.BioEntity' where classname ='lcsb.mapviewer.model.map.AnnotatedObject';




-- UPDATE 12.0.0~alpha.0/V12.0.0.20171004__uploaded_files_that_are_uploaded_in_chunks_should_have_info_about_how_big_should_be_the_file.sql

--uploaded files that are uploaded in chunks should have info about how big should be the file
alter table file_entry add column length bigint;
update file_entry set length = octet_length(filecontent);

--add foreign key
alter table file_entry add column owner_iddb integer;
ALTER TABLE file_entry ADD CONSTRAINT file_entry_owner_constraint FOREIGN KEY (owner_iddb)
      REFERENCES public.user_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

--add owners for layout files 
update file_entry SET owner_iddb = (select (max(creator_iddb)) from layout where file_entry_iddb = file_entry.iddb);      

-- UPDATE 12.0.0~alpha.0/V12.0.0.20171115__clear_invalid_urls_from_miriam_connector.sql

-- clear invalid urls from miriam connector
delete from cachequery where type = (select iddb from cache_type where classname='lcsb.mapviewer.annotation.services.MiriamConnector') and value = 'INVALID';

-- argument for neutral color scheme
alter table user_table add column neutralcolor bytea;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20171121__add_default_positioning_of_map_when_session_data_is_not_available.sql

-- column which indicates that this overlay should be shown on startup 
alter table layout add column defaultoverlay boolean default false;

-- default positioning of map when session data is not available
alter table model_table add column defaultzoomlevel integer default null;
alter table model_table add column defaultcenterx double precision default null;
alter table model_table add column defaultcentery double precision default null;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20180116__clear_chemical_cache.sql

-- clear chemical db
delete from cachequery where type = (select iddb from cache_type where classname='lcsb.mapviewer.annotation.services.ChemicalParser');


-- UPDATE 12.0.0~alpha.0/V12.0.0.20180117__column_to_store_which_annotator_is_responsible_for_given_miriam_data.sql

-- column to store which annotator is responsible for given miriam data
alter table miriam_data_table add column annotator varchar(256) default null;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20180125__kegg_annotator.sql

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.KeggAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.KeggAnnotator');

UPDATE class_annotator_annotators_table  SET annotator_name = 'TAIR' WHERE annotator_name = 'TAIR Locus';



-- UPDATE 12.0.0~alpha.0/V12.0.0.20180126__create_annotators_params_table.sql

CREATE SEQUENCE annotators_params_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE annotators_params_table
(
  iddb integer NOT NULL DEFAULT nextval('annotators_params_table_iddb_seq'::regclass),
  annotationschema_iddb integer,
  annotator_classname character varying(255) NOT NULL,  
  name character varying(255) NOT NULL,
  value character varying(255) NOT NULL,
  CONSTRAINT annotators_params_pkey PRIMARY KEY (iddb),
  CONSTRAINT annotators_params_user_annotation_schema_fk FOREIGN KEY (annotationschema_iddb)
      REFERENCES user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- UPDATE 12.0.0~alpha.0/V12.0.0.20180206__add_data_for_kinetics.sql

alter table element_table drop column if exists boundarycondition;
alter table element_table add boundarycondition boolean;

alter table element_table drop column if exists constant;
alter table element_table add constant boolean;

alter table element_table drop column if exists substanceunits;
alter table element_table add substanceunits varchar(255);

alter table reaction_table drop column if exists kineticlaw;

alter table reaction_table drop column if exists kinetics_iddb;
alter table reaction_table add kinetics_iddb integer;

drop table if exists kinetic_law_parameters;
drop table if exists kinetic_law_functions;
drop table if exists kinetic_law_elements;
drop table if exists sbml_function_arguments;
drop table if exists sbml_unit_factor;
DROP SEQUENCE if exists sbml_unit_factor_iddb_seq;
drop table if exists sbml_kinetics;
DROP SEQUENCE if exists sbml_kinetics_iddb_seq;
drop table if exists sbml_function;
DROP SEQUENCE if exists sbml_function_iddb_seq;
drop table if exists model_parameters;
drop table if exists sbml_parameter;
DROP SEQUENCE if exists sbml_parameter_iddb_seq;
drop table if exists sbml_unit;
DROP SEQUENCE if exists sbml_unit_iddb_seq;

--definition of sbml unit

CREATE SEQUENCE sbml_unit_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_unit
(
  iddb integer NOT NULL DEFAULT nextval('sbml_unit_iddb_seq'::regclass),
  unitid  varchar(255),  
  name  varchar(255),
  model_iddb integer NOT NULL,
  
  CONSTRAINT sbml_unit_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_unit_model_fk FOREIGN KEY (model_iddb)
      REFERENCES public.model_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

--definition of sbml parameter
CREATE SEQUENCE sbml_parameter_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_parameter
(
  iddb integer NOT NULL DEFAULT nextval('sbml_parameter_iddb_seq'::regclass),
  parameterid  varchar(255),  
  name  varchar(255),
	value  numeric,
	units_iddb integer,
  
  CONSTRAINT sbml_parameter_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_parameter_units_fk FOREIGN KEY (units_iddb)
      REFERENCES public.sbml_unit (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);


--definition of many to many relation between model and sbml parameter
CREATE TABLE model_parameters
(
  model_id integer NOT NULL,
  parameter_id integer NOT NULL,  
  CONSTRAINT model_parameters_unique UNIQUE (model_id, parameter_id),
  CONSTRAINT model_parameters_model_fk FOREIGN KEY (model_id)
      REFERENCES public.model_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT model_parameters_parameter_fk FOREIGN KEY (parameter_id)
      REFERENCES public.sbml_parameter (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

--definition of sbml function
CREATE SEQUENCE sbml_function_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_function
(
  iddb integer NOT NULL DEFAULT nextval('sbml_function_iddb_seq'::regclass),
  functionid  varchar(255),  
  name  varchar(255),
  definition  text,
  model_iddb integer NOT NULL,
  
  CONSTRAINT sbml_function_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_function_model_fk FOREIGN KEY (model_iddb)
      REFERENCES public.model_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

--definition of sbml kinetics
CREATE SEQUENCE sbml_kinetics_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_kinetics
(
  iddb integer NOT NULL DEFAULT nextval('sbml_function_iddb_seq'::regclass),
  definition  text,
  
  CONSTRAINT sbml_kinetics_pk PRIMARY KEY (iddb)
);

ALTER TABLE reaction_table ADD FOREIGN KEY (kinetics_iddb) REFERENCES sbml_kinetics(iddb);


--definition of sbml kinetics
CREATE SEQUENCE sbml_unit_factor_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_unit_factor
(
  iddb integer NOT NULL DEFAULT nextval('sbml_unit_factor_iddb_seq'::regclass),
  unit_iddb  integer not null,
  exponent  integer not null default 1,
  scale  integer not null default 0,
  multiplier  numeric not null default 1.0,
  unittype varchar(255), 
  
  CONSTRAINT sbml_unit_factor_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_unit_factor_unit_fk FOREIGN KEY (unit_iddb)
      REFERENCES public.sbml_unit (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
  
);

CREATE TABLE sbml_function_arguments
(
  idx integer NOT NULL,
  sbml_function_iddb integer not null,
  argument_name varchar(255), 
  
  CONSTRAINT sbml_function_arguments_sbml_function_fk FOREIGN KEY (sbml_function_iddb)
      REFERENCES public.sbml_function (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
  
);

CREATE TABLE kinetic_law_parameters
(
  kinetic_law_id integer NOT NULL,
  parameter_id integer not null,
  
  CONSTRAINT kinetic_law_parameters_unique UNIQUE (kinetic_law_id, parameter_id),
  CONSTRAINT kinetic_law_parameters_sbml_kinetics_fk FOREIGN KEY (kinetic_law_id)
      REFERENCES public.sbml_kinetics (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT kinetic_law_parameters_parameter_fk FOREIGN KEY (parameter_id)
      REFERENCES public.sbml_parameter (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE kinetic_law_functions
(
  kinetic_law_id integer NOT NULL,
  function_id integer not null,
  
  CONSTRAINT kinetic_law_functions_unique UNIQUE (kinetic_law_id, function_id),
  CONSTRAINT kinetic_law_functions_sbml_kinetics_fk FOREIGN KEY (kinetic_law_id)
      REFERENCES public.sbml_kinetics (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT kinetic_law_functions_function_fk FOREIGN KEY (function_id)
      REFERENCES public.sbml_function (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE kinetic_law_elements
(
  kinetic_law_id integer NOT NULL,
  element_id integer not null,
  
  CONSTRAINT kinetic_law_elements_unique UNIQUE (kinetic_law_id, element_id),
  CONSTRAINT kinetic_law_elements_sbml_kinetics_fk FOREIGN KEY (kinetic_law_id)
      REFERENCES public.sbml_kinetics (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT kinetic_law_elements_element_fk FOREIGN KEY (element_id)
      REFERENCES public.element_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);



-- UPDATE 12.0.0~alpha.1/V12.0.0.20180311__order_of_data_overlays_added.sql

alter table layout add order_index integer default 0;
update layout l set order_index = (select count(*) from layout where iddb<l.iddb and creator_iddb=l.creator_iddb and l.model_iddb=model_iddb) +1;


-- UPDATE 12.0.0~beta.0/V12.0.0.20180314__create_structures_for_plugin_data.sql

CREATE SEQUENCE plugin_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE plugin_table
(
  iddb integer NOT NULL DEFAULT nextval('plugin_table_iddb_seq'::regclass),
  hash character varying(255) NOT NULL,
  name character varying(255) NOT NULL,
  version character varying(255) NOT NULL,
  CONSTRAINT plugin_pkey PRIMARY KEY (iddb),
  CONSTRAINT plugin_hash_unique UNIQUE (hash)
);

CREATE TABLE plugin_urls
(
  plugin_iddb integer NOT NULL,
  url character varying(1024) NOT NULL,
  CONSTRAINT plugin_urls_pkey PRIMARY KEY (plugin_iddb, url),
  CONSTRAINT plugin_urls_fk FOREIGN KEY (plugin_iddb)
      REFERENCES public.plugin_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE SEQUENCE plugin_data_entry_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE plugin_data_entry
(
  iddb integer NOT NULL DEFAULT nextval('plugin_table_iddb_seq'::regclass),
  plugin_iddb integer NOT NULL,
  user_iddb integer,
  entry_key character varying(1024) NOT NULL,
  entry_value character varying(2048) NOT NULL,
  CONSTRAINT plugin_data_entry_pkey PRIMARY KEY (iddb),
  CONSTRAINT plugin_data_entry_plugin_fk FOREIGN KEY (plugin_iddb)
      REFERENCES public.plugin_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT plugin_data_entry_user_fk FOREIGN KEY (user_iddb)
      REFERENCES public.user_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);


-- UPDATE 12.0.0~beta.1/V12.0.0.20180402__create_gui_preferences_table.sql

CREATE SEQUENCE user_gui_preferences_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE user_gui_preferences
(
  iddb integer NOT NULL DEFAULT nextval('user_gui_preferences_iddb_seq'::regclass),
  key character varying(255) NOT NULL,
  value character varying(255) NOT NULL,
  annotation_schema_iddb integer NOT NULL,
  CONSTRAINT user_gui_preferences_fk FOREIGN KEY (annotation_schema_iddb)
      REFERENCES public.user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT user_gui_preferences_key_unique UNIQUE (key, annotation_schema_iddb)
);


-- UPDATE 12.0.0~beta.1/V12.0.0.20180405__add_table_for_reaction_stochiometry.sql

alter table node_table add column stoichiometry numeric(9,2) default null;


-- UPDATE 12.0.0~beta.2/V12.0.0.20180423__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.3/V12.0.0.20180410__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.3/V12.0.0.20180411__drop_data_mining_structures.sql

-- drop data mining structures
drop table datamining_references ;
drop table datamining_connections;
drop table datamining_table;
drop table data_mining_set_table ;
drop sequence datamining_table_iddb_seq;
drop sequence data_mining_set_iddb_seq;

-- change project status from int to string

alter table project_table add column status_string varchar(255) default 'UNKNOWN';
update project_table set status_string = 'PARSING_DATA' where status = 1;
update project_table set status_string = 'ANNOTATING' where status = 2;
update project_table set status_string = 'UPLOADING_TO_DB' where status = 3;
update project_table set status_string = 'EXTENDING_MODEL' where status = 4;
update project_table set status_string = 'GENERATING_IMAGES' where status = 5;
update project_table set status_string = 'CACHING' where status = 6;
update project_table set status_string = 'DONE' where status = 7;
update project_table set status_string = 'FAIL' where status = 8;
update project_table set status_string = 'CACHING_MIRIAM' where status = 9;
update project_table set status_string = 'VALIDATING_MIRIAM' where status = 10;
update project_table set status_string = 'REMOVING' where status = 11;
update project_table set status_string = 'CACHING_CHEMICAL' where status = 12;
update project_table set status_string = 'CACHING_DRUG' where status = 13;
update project_table set status_string = 'CACHING_MI_RNA' where status = 14;
alter table project_table drop column status ;
alter table project_table rename COLUMN status_string to status;

-- remove DATA MINING status
update project_table set status = 'UNKNOWN' where status = 'EXTENDING_MODEL';


-- UPDATE 12.0.0~beta.3/V12.0.0.20180427__add_field_to_determine_implementation_of_map_canvas.sql

-- alternative implementation of map canvas

alter table project_table add column google_map_license_accept_date timestamp without time zone;
alter table project_table add column map_canvas_type character varying default 'OPEN_LAYERS';


-- UPDATE 12.0.0~beta.3/V12.0.0.20180530__fix_LAYOUT_MANAGEMENT_for_new_API.sql

-- there is problem with privileges with new API
update privilege_table set privilege_class_type_db ='OBJECT_PRIVILEGE' where type = 'LAYOUT_MANAGEMENT';

-- UPDATE 12.0.0~beta.4/V12.0.0.20180607__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.5/V12.0.0.20180608__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.6/V12.0.0.20180628__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.7/V12.0.0.20180705__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0/V12.0.0.20180716__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.1/V12.0.1.20180723__duplicates_in_reaction_ids_resolved.sql

-- issue #461 - duplicates in reaction ids resolved
update reaction_table r set  idreaction=concat(r.idreaction,'_',r.iddb) from (select idreaction, model_iddb from reaction_table group by idreaction, model_iddb having count(*)>1) t where r.idreaction=t.idreaction and r.model_iddb=t.model_iddb;


-- UPDATE 12.0.2/V12.0.2.20180731__duplicates_in_reaction_ids_resolved.sql

-- issue #461 - duplicates in reaction ids resolved
update reaction_table r set  idreaction=concat(r.idreaction,'_',r.iddb) from (select idreaction, model_iddb from reaction_table group by idreaction, model_iddb having count(*)>1) t where r.idreaction=t.idreaction and r.model_iddb=t.model_iddb;


-- UPDATE 12.0.3/V12.0.3.20180827__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.4/V12.0.4.20180830__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo
