

-- UPDATE 9/V9.20160629__miriam_connector_added.sql

insert into cache_type select 3,365,'lcsb.mapviewer.annotation.services.MiriamConnector' where (select count(*) from cache_type where iddb = 3) =0;

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1022, 'Installation script fixed', 'BUG_FIX', null, null);

insert into framework_version(version,"time", svnversion) values (9, timestamp'2016-06-29',1023);


-- UPDATE 10/V10.0.0.20160517__remove_meta_id.sql

-- remove metaid columns (some useless identifier)
alter table species_table drop column metaid;
alter table reaction_table drop column metaid;
alter table model_table drop column metaid;


-- UPDATE 10/V10.0.0.20160518__add_inputdata_for_project.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Search by reaction id is not case sensitive', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'CellDesigner font size is processed properly', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));

--column with input file data for a project
alter table project_table add column inputdata bytea;
ALTER TABLE project_table ADD COLUMN inputfilename varchar;

-- UPDATE 10/V10.0.0.20160519__changelog_updated.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Project info tab available for users', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 10/V10.0.0.20160520__UcscReferenceGenomeConnector_implemented.sql

INSERT INTO cache_type(iddb, validity, classname)
VALUES (19, 28, 'lcsb.mapviewer.annotation.services.genome.UcscReferenceGenomeConnector');


-- UPDATE 10/V10.0.0.20160523__big_file_entry_table_created.sql

CREATE SEQUENCE public.big_file_entry_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.big_file_entry
(
  iddb integer NOT NULL DEFAULT nextval('big_file_entry_iddb_seq'::regclass),
  url text,
  localpath text,
  downloaddate timestamp without time zone,
  downloadprogress double precision,
  downloadthreadid integer,
  removed boolean default false,
  CONSTRAINT big_file_entry_pkey PRIMARY KEY (iddb)
)
WITH (
  OIDS=FALSE
);


-- UPDATE 10/V10.0.0.20160524__reference_genome_table_created.sql

drop table if exists public.reference_genome;
drop SEQUENCE if exists public.reference_genome_iddb_seq;
CREATE SEQUENCE public.reference_genome_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.reference_genome
(
  iddb integer NOT NULL DEFAULT nextval('reference_genome_iddb_seq'::regclass),
  organism_iddb integer NOT NULL ,
  "type" varchar(255),
  version varchar(255),
  sourceurl text,
  downloadprogress double precision,
  CONSTRAINT reference_genome_pkey PRIMARY KEY (iddb),
  CONSTRAINT reference_genome_organism_fk FOREIGN KEY (organism_iddb)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);


-- UPDATE 10/V10.0.0.20160527__add_type_organism_version_to_reference_genome.sql

--obligatory fields for reference genome table
alter table reference_genome alter column "type" set not null;
alter table reference_genome alter column organism_iddb set not null;
alter table reference_genome alter column "version" set not null;


--gene mapping files table for reference genome table
drop table if exists public.reference_genome_gene_mapping;
drop SEQUENCE if exists public.reference_genome_gene_mapping_iddb_seq;
CREATE SEQUENCE public.reference_genome_gene_mapping_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.reference_genome_gene_mapping
(
  iddb integer NOT NULL DEFAULT nextval('reference_genome_gene_mapping_iddb_seq'::regclass),
  referencegenome_iddb integer NOT NULL,
  name varchar(255) not null,
  sourceurl text not null,
  downloadprogress double precision,
  CONSTRAINT reference_genome_gene_mapping_pkey PRIMARY KEY (iddb),
  CONSTRAINT reference_genome_gene_mapping_reference_genome_fk FOREIGN KEY (referencegenome_iddb)
      REFERENCES public.reference_genome (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT reference_genome_gene_mapping_unique_name UNIQUE (referencegenome_iddb, name)
      

)
WITH (
  OIDS=FALSE
);


-- UPDATE 10/V10.0.0.20160601__genome_managing_is_availabvle_by_default_for_admin.sql

-- fixing privileges for admin (genome managing is availabvle by default for admin)
insert into privilege_table (privilege_class_type_db,level,type,idobject,user_iddb) select 'BASIC_PRIVILEGE',1,11,null, t.iddb from user_table t where iddb=1 and not(t.iddb in (select user_iddb from privilege_table where type=11));


-- UPDATE 10/V10.0.0.20160606__project_has_organism_id.sql

-- project should have organism id
alter table project_table  add column organism_iddb integer;
ALTER TABLE project_table ADD CONSTRAINT project_organism_constraint FOREIGN KEY (organism_iddb)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

-- UPDATE 10/V10.0.0.20160621__big_file_entry_renamed_to_file_entry.sql

-- reorganizing files in the system
alter table big_file_entry rename to file_entry;

alter table file_entry add column filecontent bytea;
alter table file_entry add column file_type_db varchar(255);
alter table file_entry add column originalfilename varchar(255);

-- all files up to this point were big files
update file_entry set file_type_db = 'BIG_FILE_ENTRY';

--and now we move content of files from layout file to file_entry table
--tmp column
alter table file_entry add column layout_id_tmp integer;
--move content content
insert into file_entry (filecontent,file_type_db,originalfilename,layout_id_tmp) select inputdata, 'UPLOADED_FILE_ENTRY', 'layout_'||iddb||'.txt',iddb from layout where inputdata is not null;

--add foreign key
alter table layout add column file_entry_iddb integer;
ALTER TABLE layout ADD CONSTRAINT layout_file_constraint FOREIGN KEY (file_entry_iddb)
      REFERENCES public.file_entry (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

--put data to foreign key      
update layout l set file_entry_iddb = (select iddb from file_entry ef where ef.layout_id_tmp = l.iddb) where l.inputdata is not null;

--remove unused columns 
alter table file_entry drop column layout_id_tmp;
alter table layout drop column inputdata;


-- UPDATE 10/V10.0.0.20160629__changelog_updated.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Hiding left panel', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Coordinates in url', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Unexpected errors when uploading layouts', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));

delete from cachequery where type = (select iddb from cache_type where classname = 'lcsb.mapviewer.annotation.services.DrugbankHTMLParser') and query like 'drug:%';

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Corrupted drug names', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));


-- UPDATE 10/V10.0.0.20160727__changelog_updated.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Out of memory when caching a lot of data', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Management of overlays in admin panel', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Zooming issue when searching for results on submaps', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Exception when accessing non-existing project', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
  


-- UPDATE 10/V10.0.0.20160728__changelog_updated.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1056, 'Visualization of text mining', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));


-- UPDATE 10/V10.0.0.20160822__changelog_updated.sql

insert into framework_version(version,"time", svnversion) values (10, timestamp'2016-08-22',1119);


-- UPDATE 10.0.1/V10.0.1.20160907__changelog_is_not_managed_over_db.sql

drop table changelog;
drop table framework_version;

-- UPDATE 10.0.1/V10.0.1.20160909__TRIGGER_REACTION_discriminator_renamed.sql

-- fix on issue #8
update reaction_table set reaction_type_db='REDUCED_TRIGGER_REACTION' where reaction_type_db = 'TRIGGER_REACTION';
update reaction_table set reaction_type_db='REDUCED_PHYSICAL_STIMULATION' where reaction_type_db = 'PHYSICAL_STIMULATION_REACTION';



-- UPDATE 10.0.2/V10.0.2.20160928__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 10.0.3/V10.0.3.20160926__alias_type_db_changed_to_correctly_resolve_species_type.sql

-- change alias types for new aliases implementation 
update alias_table set alias_type_db = 'ANTISENSE_RNA_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Antisense RNA');

--chemical_alias (should never happen)
update alias_table set alias_type_db = 'CHEMICAL_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Chemical');

update alias_table set alias_type_db = 'ION_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Ion');

update alias_table set alias_type_db = 'SIMPLE_MOLECULE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='SimpleMolecule');

-- complex_alias (nothing should change)
update alias_table set alias_type_db = 'Complex Species Alias' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='COMPLEX_SPECIES');

update alias_table set alias_type_db = 'DEGRADED_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Degraded');

update alias_table set alias_type_db = 'DRUG_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Drug');

update alias_table set alias_type_db = 'GENE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Gene');

update alias_table set alias_type_db = 'PHENTOYPE_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Phenotype');

-- protein_alias (this should never happen)
update alias_table set alias_type_db = 'PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Protein');

update alias_table set alias_type_db = 'GENERIC_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='GENERIC_PROTEIN');

update alias_table set alias_type_db = 'ION_CHANNEL_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='ION_CHANNEL_PROTEIN');

update alias_table set alias_type_db = 'RECEPTOR_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='RECEPTOR_PROTEIN');

update alias_table set alias_type_db = 'TRUNCATED_PROTEIN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='TRUNCATED_PROTEIN');

update alias_table set alias_type_db = 'RNA_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='RNA');

update alias_table set alias_type_db = 'UNKNOWN_ALIAS' where iddb in (select alias_table.iddb from alias_table , species_table t where alias_table.idelementdb=t.iddb and t.species_type_db ='Unknown');

-- for artifitial compartment alias we have name in the title column so rename it (later on we will add names for other elements)
ALTER TABLE "alias_table" RENAME COLUMN "title" TO "name";


-- UPDATE 10.0.3/V10.0.3.20160929__migrate_species_properties_to_alias.sql

-- migrate info about abbreviation
ALTER TABLE alias_table ADD COLUMN abbreviation character varying(255);
update alias_table set abbreviation = (select species_table.abbreviation from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column abbreviation;

-- migrate info about formula
ALTER TABLE alias_table ADD COLUMN formula character varying(255);
update alias_table set formula = (select species_table.formula from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column formula;

-- migrate info about full name
ALTER TABLE alias_table ADD COLUMN fullname character varying(255);
update alias_table set fullname = (select species_table.fullname from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column fullname;

-- name
update alias_table set name = (select species_table.name from species_table where alias_table.idelementdb =  species_table.iddb) where name is null or name ='';

-- notes
ALTER TABLE alias_table ADD COLUMN notes text;
update alias_table set notes = (select species_table.notes from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column notes;

-- symbol
ALTER TABLE alias_table ADD COLUMN symbol character varying(255);
update alias_table set symbol = (select species_table.symbol from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column symbol;

-- charge
ALTER TABLE alias_table ADD COLUMN charge integer;
update alias_table set charge = (select species_table.charge from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column charge;

-- homodimer
ALTER TABLE alias_table ADD COLUMN homodimer integer;
update alias_table set homodimer = (select species_table.homodimer from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column homodimer;

-- hypothetical
ALTER TABLE alias_table ADD COLUMN hypothetical boolean;
update alias_table set hypothetical = (select species_table.hypothetical from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column hypothetical;

-- initial amount
ALTER TABLE alias_table ADD COLUMN initialamount integer;
update alias_table set initialamount = (select species_table.initialamount from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column initialamount;

-- initial concentration
ALTER TABLE alias_table ADD COLUMN initialconcentration integer;
update alias_table set initialconcentration = (select species_table.initialconcentration from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column initialconcentration;

--only substance unit
ALTER TABLE alias_table ADD COLUMN onlysubstanceunits boolean;
update alias_table set onlysubstanceunits = (select species_table.onlysubstanceunits from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column onlysubstanceunits;

-- position to compartment
ALTER TABLE alias_table ADD COLUMN positiontocompartment character varying(255);
update alias_table set positiontocompartment = (select species_table.positiontocompartment from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column positiontocompartment;

-- inchi
ALTER TABLE alias_table ADD COLUMN inchi text;
update alias_table set inchi = (select species_table.inchi from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column inchi;

-- inchi key
ALTER TABLE alias_table ADD COLUMN inchikey character varying(255);
update alias_table set inchikey = (select species_table.inchikey from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column inchikey;

-- smiles
ALTER TABLE alias_table ADD COLUMN smiles text;
update alias_table set smiles = (select species_table.smiles from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column smiles;

-- structural state
ALTER TABLE alias_table ADD COLUMN structuralstate character varying(255);
update alias_table set structuralstate = (select species_table.structuralstate from species_table where alias_table.idelementdb =  species_table.iddb);
alter table species_table drop column structuralstate;


-- UPDATE 10.0.3/V10.0.3.20160930__migrate_related_tables_from_species_to_alias.sql

-- modification residues
	CREATE SEQUENCE modification_residue_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE modification_residue_table_new
(
  iddb integer NOT NULL DEFAULT nextval('modification_residue_table_iddb_seq'::regclass),
  angle double precision,
  idmodificationresidue character varying(255),
  name character varying(255),
  side character varying(255),
  size double precision,
  idspeciesdb integer NOT NULL,
  state integer,
  CONSTRAINT modification_residue_pkey PRIMARY KEY (iddb),
  CONSTRAINT modification_residue_species_fk FOREIGN KEY (idspeciesdb)
      REFERENCES public.alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO modification_residue_table_new (angle, idmodificationresidue, name, side, size, idspeciesdb,state) select modification_residue_table.angle, modification_residue_table.idmodificationresidue, modification_residue_table.name, modification_residue_table.side, modification_residue_table.size, alias_table.iddb, modification_residue_table.state from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join modification_residue_table on species_table.iddb = modification_residue_table.idspeciesdb;

drop table modification_residue_table;

-- mapping between miriam data and element
CREATE TABLE public.element_miriam
(
  element_id integer NOT NULL,
  miriam_id integer NOT NULL,
  CONSTRAINT element_miriam_pkey PRIMARY KEY (element_id, miriam_id),
  CONSTRAINT element_miriam_element_fk FOREIGN KEY (element_id)
      REFERENCES public.alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT element_miriam_miriam_fk FOREIGN KEY (miriam_id)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- migrate data
insert into element_miriam (miriam_id, element_id) select miriam_data_table.iddb, alias_table.iddb from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join miriam_data_table on species_table.iddb = miriam_data_table.element_iddb;

alter table miriam_data_table drop column element_iddb;

-- former symbol list
CREATE TABLE element_former_symbols_new
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  symbol character varying(255),
  CONSTRAINT element_former_symbols_pk PRIMARY KEY (iddb, idx),
  CONSTRAINT element_former_symbols_fk FOREIGN KEY (iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

insert into element_former_symbols_new (iddb, idx, symbol) 
select alias_table.iddb, element_former_symbols.idx, element_former_symbols.symbol from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join element_former_symbols on species_table.iddb = element_former_symbols.iddb;

drop table element_former_symbols;

---synonyms list
CREATE TABLE element_synonyms_new
(
  iddb integer NOT NULL,
  idx integer NOT NULL,
  synonym character varying(255),
  CONSTRAINT element_synonyms_pk PRIMARY KEY (iddb, idx),
  CONSTRAINT element_synonyms_fk FOREIGN KEY (iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

insert into element_synonyms_new (iddb, idx, synonym) 
select alias_table.iddb, element_synonyms.idx, element_synonyms.synonym from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join element_synonyms on species_table.iddb = element_synonyms.iddb;

drop table element_synonyms;

--- antisense rna regions
CREATE TABLE antisense_rna_region_table_new
(
  iddb integer NOT NULL DEFAULT nextval('antisense_rna_region_table_iddb_seq'::regclass),
  idantisensernaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  idspeciesdb integer,
  state integer,
  type integer,
  CONSTRAINT antisense_rna_region_table_pk PRIMARY KEY (iddb),
  CONSTRAINT antisense_rna_region_table_fk FOREIGN KEY (idspeciesdb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO antisense_rna_region_table_new ( idantisensernaregion, name, pos, size, idspeciesdb,state,type) 
select antisense_rna_region_table.idantisensernaregion, antisense_rna_region_table.name, antisense_rna_region_table.pos, antisense_rna_region_table.size, alias_table.iddb, antisense_rna_region_table.state, antisense_rna_region_table.type from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join antisense_rna_region_table on species_table.iddb = antisense_rna_region_table.idspeciesdb;

drop table antisense_rna_region_table;

-- rna
-- modification residues
CREATE SEQUENCE rna_region_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE rna_region_table_new
(
  iddb integer NOT NULL DEFAULT nextval('rna_region_table_iddb_seq'::regclass),
  idrnaregion character varying(255),
  name character varying(255),
  pos double precision,
  size double precision,
  idspeciesdb integer,
  state integer,
  type character varying(255),
  CONSTRAINT rna_region_table_pk PRIMARY KEY (iddb),
  CONSTRAINT rna_region_table_fk FOREIGN KEY (idspeciesdb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO rna_region_table_new ( idrnaregion, name, pos, size, idspeciesdb,state) 
select rna_region_table.idrnaregion, rna_region_table.name, rna_region_table.pos, rna_region_table.size, alias_table.iddb, rna_region_table.state from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join rna_region_table on species_table.iddb = rna_region_table.idspeciesdb;

drop table rna_region_table;
drop sequence rna_region_table_idrnaregiondb_seq;


-- UPDATE 10.0.3/V10.0.3.20161003__refactor_datamining_table.sql

-- data mining
CREATE SEQUENCE datamining_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 51016
  CACHE 1;

CREATE TABLE datamining_table
(
  iddb integer NOT NULL DEFAULT nextval('datamining_table_iddb_seq'::regclass),
  old_idbb integer,
  description text,
  type integer,
  element_iddb integer NOT NULL,
  CONSTRAINT missingconnection_pk PRIMARY KEY (iddb),
  CONSTRAINT missingconnection_fk FOREIGN KEY (element_iddb)
      REFERENCES alias_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_table ( old_idbb, description, type, element_iddb) 
select datamining.iddb, datamining.description, datamining.type, alias_table.iddb as element_iddb from 
alias_table inner join species_table on alias_table.idelementdb = species_table.iddb inner join datamining on species_table.iddb = datamining.element_iddb;

CREATE TABLE datamining_references
(
  idx integer NOT NULL,
  datamining_iddb integer NOT NULL,
  references_iddb integer NOT NULL,
  CONSTRAINT datamining_references_pk PRIMARY KEY (datamining_iddb, idx),
  CONSTRAINT datamining_references_fk_data_mining FOREIGN KEY (datamining_iddb)
      REFERENCES datamining_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_references_fk_miriam FOREIGN KEY (references_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_references ( idx, datamining_iddb, references_iddb) 
select datamining_miriam_data_table.idx, datamining_table.iddb, datamining_miriam_data_table.references_iddb from datamining_table inner join datamining_miriam_data_table on datamining_table.old_idbb = datamining_miriam_data_table.datamining_iddb ;

drop table datamining_miriam_data_table;
alter table datamining_references rename column datamining_iddb  to datamining_table_iddb ;


drop table if exists datamining_connections;
CREATE TABLE datamining_connections
(
  idx integer NOT NULL,
  datamining_table_iddb integer NOT NULL,
  suggestedconnections_iddb integer NOT NULL,
  CONSTRAINT datamining_connections_pk PRIMARY KEY (datamining_table_iddb, idx),
  CONSTRAINT datamining_connections_fk_data_mining FOREIGN KEY (datamining_table_iddb)
      REFERENCES datamining_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT datamining_connections_fk_miriam FOREIGN KEY (suggestedconnections_iddb)
      REFERENCES miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

INSERT INTO datamining_connections ( idx, datamining_table_iddb, suggestedconnections_iddb) 
select datamining_suggested_connections.idx, datamining_table.iddb, datamining_suggested_connections.suggestedconnections_iddb from datamining_table inner join datamining_suggested_connections on datamining_table.old_idbb = datamining_suggested_connections.datamining_iddb ;

drop table datamining_suggested_connections;

alter table datamining_table drop column old_idbb;

drop table datamining;

drop table associated_phenotype_element_table;

drop table external_project;
drop table external_user;

-- clean info about annotations
delete from class_annotator_annotators_table  ;
delete from class_annotator_table  ;
delete from class_required_annotation_miriam_type_table  ;
delete from class_required_annotation_table  ;
delete from class_valid_annotation_miriam_type_table  ;
delete from class_valid_annotation_table  ;
update user_table  set annotationschema_iddb =null;
delete from user_annotation_schema_table;


-- UPDATE 10.0.3/V10.0.3.20161004__drop_connection_from_reaction_to_alias.sql

-- drop old species implementation

alter table node_table drop column element_iddb;
alter table alias_table drop column idelementdb;
drop table species_table;

alter table alias_table rename column aliasid to elementid;


-- UPDATE 10.0.3/V10.0.3.20161005__move_connection_from_species_to_alias_for_submodel_connection_table.sql

alter table submodel_connection_table rename fromalias_iddb to fromelement_iddb;
alter table submodel_connection_table rename toalias_iddb to toelement_iddb;

alter table alias_table rename to element_table;

update element_table set alias_type_db ='Bottom square Compartment' where alias_type_db = 'Bottom square Compartment Alias';
update element_table set alias_type_db ='Left square Compartment' where alias_type_db = 'Left square Compartment Alias';
update element_table set alias_type_db ='Oval Compartment' where alias_type_db = 'Oval Compartment Alias';
update element_table set alias_type_db ='Compartment' where alias_type_db = 'Compartment Alias';
update element_table set alias_type_db ='Pathway Compartment' where alias_type_db = 'Artifitial Compartment Alias';
update element_table set alias_type_db ='Right square Compartment' where alias_type_db = 'Right square Compartment Alias';
update element_table set alias_type_db ='Square Compartment' where alias_type_db = 'Square Compartment Alias';
update element_table set alias_type_db ='Top square Compartment' where alias_type_db = 'Top square Compartment Alias';

alter table node_table drop column if exists element_iddb;
alter table node_table rename alias_iddb to element_iddb;

update element_table set alias_type_db ='Complex' where alias_type_db = 'Complex Species Alias';
update element_table set alias_type_db ='Species' where alias_type_db = 'Species Alias';

alter table element_table rename alias_type_db  to element_type_db;
alter table element_table  rename idcomplexaliasdb to idcomplexdb;

alter table element_table  rename aliasstatelabel to statelabel;
alter table element_table  rename aliasstateprefix to stateprefix;


-- UPDATE 10.0.3/V10.0.3.20161006__rename_compartmentalias_iddb_to_compartment_iddb.sql

alter table element_table  rename compartmentalias_iddb to compartment_iddb;


-- UPDATE 10.0.3/V10.0.3.20161007__update_compartment_iddb_and_complex_iddb_depending_on_parent_type.sql

update element_table set idcomplexdb=parent_iddb where idcomplexdb is null and parent_iddb is not null and parent_iddb in (select iddb from element_table where element_type_db= 'Complex');

update element_table set compartment_iddb = parent_iddb where compartment_iddb is null and parent_iddb is not null and parent_iddb in (select iddb from element_table where element_type_db<> 'Complex');

alter table element_table  drop COLUMN parent_iddb ;

alter SEQUENCE alias_table_iddb_seq rename to element_table_iddb_seq;

drop sequence associated_phenotype_element_table_iddb_seq;

drop sequence layout_iddb_seq;

alter sequence layout_iddb_seq1 rename to layout_iddb_seq;

drop sequence search_index_table_iddb_seq;

alter sequence search_index_table_iddb_seq1 rename to search_index_table_iddb_seq;

alter table antisense_rna_region_table_new RENAME to antisense_rna_region_table;
alter table element_former_symbols_new rename to element_former_symbols;
alter table element_synonyms_new rename to element_synonyms;
alter table modification_residue_table_new rename to modification_residue_table;
alter table rna_region_table_new rename to rna_region_table;


-- UPDATE 10.0.3/V10.0.3.20161010__rename_miriam_type_MI_RBASE_SEQUENCE.sql

DROP TABLE IF EXISTS layerline;

update  miriam_data_table set datatype='MI_R_BASE_SEQUENCE' where datatype  ='MI_RBASE_SEQUENCE';


-- UPDATE 10.0.3/V10.0.3.20161012__add_min_max_color_to_user.sql

alter table user_table add column maxcolor bytea;
alter table user_table add column mincolor bytea;


-- UPDATE 10.0.3/V10.0.3.20161026__merging_project_and_model_logs.sql

--merging project and model logs
alter table project_table add column warnings text;
update project_table set warnings = (select creationwarnings from model_table  where project_iddb = project_table.iddb);

alter table model_table drop column creationwarnings;


-- UPDATE 10.0.3/V10.0.3.20161027__sbgn_format_moved_from_model_into_project.sql

--sbgn format moved from model into project
alter table project_table add column sbgnformat boolean default false ;
update project_table set sbgnformat = (select sbgnformat from model_table  where project_iddb = project_table.iddb);

alter table model_table drop column sbgnformat;

--PrivilegeType should be mapped in database by name not by index
alter table privilege_table add column type_string character varying;
update privilege_table set type_string = 'VIEW_PROJECT' where type = 0;
update privilege_table set type_string = 'ADD_MAP' where type = 1;
update privilege_table set type_string = 'EDIT_MISSING_CONNECTIONS_PROJECT' where type = 2;
update privilege_table set type_string = 'EDIT_COMMENTS_PROJECT' where type = 3;
update privilege_table set type_string = 'DRUG_TARGETING_ADVANCED_VIEW_PROJECT' where type = 4;
update privilege_table set type_string = 'PROJECT_MANAGEMENT' where type = 5;
update privilege_table set type_string = 'USER_MANAGEMENT' where type = 6;
update privilege_table set type_string = 'CUSTOM_LAYOUTS' where type = 7;
update privilege_table set type_string = 'LAYOUT_VIEW' where type = 8;
update privilege_table set type_string = 'CONFIGURATION_MANAGE' where type = 9;
update privilege_table set type_string = 'LAYOUT_MANAGEMENT' where type = 10;
update privilege_table set type_string = 'MANAGE_GENOMES' where type = 11;
alter table privilege_table drop column type;
alter table privilege_table rename type_string   TO type;


-- UPDATE 10.0.4/V10.0.4.20161215__fix_on_comment_visibility_in_new_version.sql

-- fix on comment visibility in new version
update feedback set tablename = 'lcsb.mapviewer.model.map.species.Species' where tablename='lcsb.mapviewer.model.map.layout.alias.SpeciesAlias';
update feedback set tablename = 'lcsb.mapviewer.model.map.species.Complex' where tablename='lcsb.mapviewer.model.map.layout.alias.ComplexAlias';

-- UPDATE 10.0.4/V10.0.4.20161228__fix_on_drugbank_parser.sql

-- fix on drugbank parser
delete from cachequery where query like 'drug:%' and type in (select iddb from cache_type  where classname ='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');
delete from cachequery where query like 'http:%' and type in (select iddb from cache_type  where classname ='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');


-- UPDATE 10.0.5/V10.0.5.20170131__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.0/V11.0.0.20170616__semantic_zooming_data.sql

-- semantic zooming
alter table element_table add column zoomlevelvisibility character varying default null;
alter table reaction_table add column zoomlevelvisibility character varying default null;


-- UPDATE 11.0.0/V11.0.0.20170627__clear_mesh_cache.sql

-- clear mesh cache
delete from cachequery  where type in (select iddb from cache_type where classname = 'lcsb.mapviewer.annotation.services.MeSHParser');

-- UPDATE 11.0.0/V11.0.0.20170628__additional_data_for_semantic_zooming.sql

-- semantic zooming
alter table element_table drop column zoomlevelvisibility ;
alter table reaction_table drop column zoomlevelvisibility ;

ALTER TABLE element_table ALTER COLUMN visibilitylevel TYPE character varying;
ALTER TABLE element_table ALTER COLUMN transparencylevel TYPE character varying;

alter table reaction_table add column visibilitylevel character varying default null;

-- UPDATE 11.0.0/V11.0.0.20170629__hierarchyviewlevel_for_layout.sql

-- semantic zooming
alter table layout add column hierarchyviewlevel integer;

-- UPDATE 11.0.0/V11.0.0.20170705__removed_cached_drugs.sql

-- removed cached drugs
delete from cachequery where query like 'drug:%' and type in (select iddb from cache_type  where classname = 'lcsb.mapviewer.annotation.services.DrugbankHTMLParser');

-- UPDATE 11.0.0/V11.0.0.20170714__some_sequences_had_too_low_values.sql

-- some sequences had too low values
DO ' 
DECLARE 
	rec 	RECORD;
	size 	INT;
BEGIN
	FOR rec IN SELECT * FROM information_schema.sequences LOOP
		EXECUTE format(''SELECT COUNT(1) FROM information_schema.tables WHERE table_name = ''''%s'''''', REPLACE(rec.sequence_name, ''_iddb_seq'', '''')) INTO size;
		IF  size = 1 THEN
			EXECUTE format(''SELECT setval(''''%s'''', (SELECT MAX(iddb)+1 FROM %I))'', rec.sequence_name, REPLACE(rec.sequence_name, ''_iddb_seq'', ''''));		
		END IF;
		EXECUTE format(''SELECT COUNT(1) FROM information_schema.tables WHERE table_name = ''''%s'''''', REPLACE(rec.sequence_name, ''_iddb_seq'', ''_table'')) INTO size;
		IF  size = 1 THEN
			EXECUTE format(''SELECT setval(''''%s'''', (SELECT MAX(iddb)+1 FROM %I))'', rec.sequence_name, REPLACE(rec.sequence_name, ''_iddb_seq'', ''_table''));
		END IF;
	END LOOP;
END ';

-- UPDATE 11.0.0/V11.0.0.20170725__add_simple_color_for_user_coloring.sql

--simple color for coloring
alter table user_table  add column simplecolor bytea;

-- UPDATE 11.0.0/V11.0.0.20170731__purge_drugbank_cached_data.sql

--drugbank targets issue 
delete from cachequery  where type in (select iddb from cache_type  where classname = 'lcsb.mapviewer.annotation.services.DrugbankHTMLParser') and not query like 'http%';


-- UPDATE 11.0.1/V11.0.1.20170908__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.2/V11.0.2.20171010__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.3/V11.0.3.20171017__update_project_directory_for_empty_project.sql

UPDATE project_table SET directory = 'a2e4822a98337283e39f7b60acf85ec9' WHERE project_id='empty' and (directory is null or directory='.');


-- UPDATE 11.0.4/V11.0.4.20171109__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.5/V11.0.5.20171109__clear_drugbank_cache.sql

---clear drugbank cache 
delete from cachequery where type = (select iddb from cache_type where classname='lcsb.mapviewer.annotation.services.DrugbankHTMLParser');


-- UPDATE 11.0.6/V11.0.6.20171214__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.7/V11.0.7.20180118__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.8/V11.0.8.20180118__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.9/V11.0.9.20180221__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.0.10/V11.0.10.20180416__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.1.0/V11.1.0.20180509__google_license_consent_for_data_overlay.sql

alter table layout add column google_license_consent boolean default false;


-- UPDATE 11.1.0/V11.1.0.20180525__add_terms_of_use_consent_for_user.sql

alter table user_table add column terms_of_use_consent boolean default false;


-- UPDATE 11.1.1/V11.1.1.20171114__new_annotators.sql

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.TairAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.TairAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.CazyAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.CazyAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.BrendaAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.BrendaAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.StitchAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.StitchAnnotator');

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.StringAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.StringAnnotator');



-- UPDATE 11.1.1/V11.1.1.20180626__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.1.2/V11.1.2.20180704__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 11.1.3/V11.1.3.20180723__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170713__add_PdbAnnotator.sql

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.PdbAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.PdbAnnotator');

-- UPDATE 12.0.0~alpha.0/V12.0.0.20170720__create_uniprot_table.sql

CREATE SEQUENCE uniprot_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

-- 1:N mapping between element and its uniprot mappings, each of which is then used to map (PDB) structures to it
CREATE TABLE uniprot_table
(
  iddb integer NOT NULL DEFAULT nextval('uniprot_table_iddb_seq'::regclass),
  element_id integer NOT NULL,  
  uniprot_id character varying(255) NOT NULL,
  CONSTRAINT uniprot_pkey PRIMARY KEY (iddb),
  CONSTRAINT uniprot_element_fk FOREIGN KEY (element_id)
      REFERENCES public.element_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);


CREATE SEQUENCE structure_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

/*
based on https://www.ebi.ac.uk/pdbe/api/doc/sifts.html best_structures API

		pdb_id: the PDB ID which maps to the UniProt ID
                chain_id: the specific chain of the PDB which maps to the UniProt ID
                coverage: the percent coverage of the entire UniProt sequence
                resolution: the resolution of the structure
                start: the structure residue number which maps to the start of the mapped sequence
                end: the structure residue number which maps to the end of the mapped sequence
                unp_start: the sequence residue number which maps to the structure start
                unp_end: the sequence residue number which maps to the structure end
                experimental_method: type of experiment used to determine structure
                tax_id: taxonomic ID of the protein's original organism
*/
CREATE TABLE structure_table
(
  iddb integer NOT NULL DEFAULT nextval('structure_table_iddb_seq'::regclass),
  uniprot_id integer NOT NULL,
  pdb_id character varying(255) NOT NULL, --should be character(4), but to be on the safe side...
  chain_id character varying(255) NOT NULL, --should be char(1), but for example 5T0C has has chains AK and BK
  struct_start integer,
  struct_end integer,
  unp_start integer,
  unp_end integer,  
  experimental_method character varying(255),
  coverage double precision,
  resolution double precision,
  tax_id integer,
  CONSTRAINT structure_pkey PRIMARY KEY (iddb),
  CONSTRAINT structure_uniprot_fk FOREIGN KEY (uniprot_id)
      REFERENCES public.uniprot_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);




-- UPDATE 12.0.0~alpha.0/V12.0.0.20170808__version_moved_from_model_into_project.sql

-- version moved from model into project
alter table project_table add column version character varying default '';
update project_table set version = model_table.mapversion from model_table where project_table.iddb = model_table.project_iddb;
alter table model_table drop column mapversion;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170809__images_moved_to_project.sql

-- images moved to project
alter table overview_image_table add column project_iddb integer;
update overview_image_table set project_iddb = model_table.project_iddb from model_table where model_table.iddb = overview_image_table.model_iddb;
delete from overview_image_table where project_iddb is null;
alter table overview_image_table drop column model_iddb;

-- project file moved to downloaded files
alter table project_table add column file_entry_iddb integer;
DO $$ 
DECLARE 
	project 	RECORD;
	last_id 	INT;
BEGIN
  FOR project IN SELECT * FROM project_table where inputData is not null LOOP
	insert into file_entry (filecontent, file_type_db, originalfilename) values
	  (project.inputdata, 'UPLOADED_FILE_ENTRY',project.inputfilename) returning iddb into last_id;
	
  	update project_table set file_entry_iddb = last_id where iddb = project.iddb ;
  	RAISE NOTICE 'Calling cs_create_job(%, %)', project.iddb, last_id ;
  END LOOP;
END $$;

alter table project_table drop column inputdata;
alter table project_table drop column inputfilename;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170814__move_notify_email_from_model_into_project.sql

-- notify email from model into project
alter table project_table add column notifyemail character varying default '';
update project_table set notifyemail = model_table.notifyemail from model_table where project_table.iddb = model_table.project_iddb;
alter table model_table drop column notifyemail;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20170822__remove_unnecessery_privileges.sql

--unnecessery privileges removed
delete from privilege_table where type='DRUG_TARGETING_ADVANCED_VIEW_PROJECT' ;
delete from privilege_table where type='EDIT_MISSING_CONNECTIONS_PROJECT' ;

-- UPDATE 12.0.0~alpha.0/V12.0.0.20170829__add_user_prferences_for_uploading_map.sql

--user prferences for uploading map
alter table user_annotation_schema_table add column annotatemodel boolean default false;
alter table user_annotation_schema_table add column autoresizemap boolean default true;
alter table user_annotation_schema_table add column cachedata boolean default true;
alter table user_annotation_schema_table add column semanticzooming boolean default false;
alter table class_required_annotation_table RENAME column requireatlestoneannotation to requireatleastoneannotation;

-- rename config annotation class name
update class_annotator_table set classname ='lcsb.mapviewer.model.map.BioEntity' where classname ='lcsb.mapviewer.model.map.AnnotatedObject';
update class_required_annotation_table set classname ='lcsb.mapviewer.model.map.BioEntity' where classname ='lcsb.mapviewer.model.map.AnnotatedObject';
update class_valid_annotation_table set classname ='lcsb.mapviewer.model.map.BioEntity' where classname ='lcsb.mapviewer.model.map.AnnotatedObject';




-- UPDATE 12.0.0~alpha.0/V12.0.0.20171004__uploaded_files_that_are_uploaded_in_chunks_should_have_info_about_how_big_should_be_the_file.sql

--uploaded files that are uploaded in chunks should have info about how big should be the file
alter table file_entry add column length bigint;
update file_entry set length = octet_length(filecontent);

--add foreign key
alter table file_entry add column owner_iddb integer;
ALTER TABLE file_entry ADD CONSTRAINT file_entry_owner_constraint FOREIGN KEY (owner_iddb)
      REFERENCES public.user_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

--add owners for layout files 
update file_entry SET owner_iddb = (select (max(creator_iddb)) from layout where file_entry_iddb = file_entry.iddb);      

-- UPDATE 12.0.0~alpha.0/V12.0.0.20171115__clear_invalid_urls_from_miriam_connector.sql

-- clear invalid urls from miriam connector
delete from cachequery where type = (select iddb from cache_type where classname='lcsb.mapviewer.annotation.services.MiriamConnector') and value = 'INVALID';

-- argument for neutral color scheme
alter table user_table add column neutralcolor bytea;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20171121__add_default_positioning_of_map_when_session_data_is_not_available.sql

-- column which indicates that this overlay should be shown on startup 
alter table layout add column defaultoverlay boolean default false;

-- default positioning of map when session data is not available
alter table model_table add column defaultzoomlevel integer default null;
alter table model_table add column defaultcenterx double precision default null;
alter table model_table add column defaultcentery double precision default null;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20180116__clear_chemical_cache.sql

-- clear chemical db
delete from cachequery where type = (select iddb from cache_type where classname='lcsb.mapviewer.annotation.services.ChemicalParser');


-- UPDATE 12.0.0~alpha.0/V12.0.0.20180117__column_to_store_which_annotator_is_responsible_for_given_miriam_data.sql

-- column to store which annotator is responsible for given miriam data
alter table miriam_data_table add column annotator varchar(256) default null;


-- UPDATE 12.0.0~alpha.0/V12.0.0.20180125__kegg_annotator.sql

DELETE FROM cache_type WHERE classname = 'lcsb.mapviewer.annotation.services.annotators.KeggAnnotator';
INSERT INTO cache_type(validity, classname) VALUES (365, 'lcsb.mapviewer.annotation.services.annotators.KeggAnnotator');

UPDATE class_annotator_annotators_table  SET annotator_name = 'TAIR' WHERE annotator_name = 'TAIR Locus';



-- UPDATE 12.0.0~alpha.0/V12.0.0.20180126__create_annotators_params_table.sql

CREATE SEQUENCE annotators_params_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE annotators_params_table
(
  iddb integer NOT NULL DEFAULT nextval('annotators_params_table_iddb_seq'::regclass),
  annotationschema_iddb integer,
  annotator_classname character varying(255) NOT NULL,  
  name character varying(255) NOT NULL,
  value character varying(255) NOT NULL,
  CONSTRAINT annotators_params_pkey PRIMARY KEY (iddb),
  CONSTRAINT annotators_params_user_annotation_schema_fk FOREIGN KEY (annotationschema_iddb)
      REFERENCES user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);

-- UPDATE 12.0.0~alpha.0/V12.0.0.20180206__add_data_for_kinetics.sql

alter table element_table drop column if exists boundarycondition;
alter table element_table add boundarycondition boolean;

alter table element_table drop column if exists constant;
alter table element_table add constant boolean;

alter table element_table drop column if exists substanceunits;
alter table element_table add substanceunits varchar(255);

alter table reaction_table drop column if exists kineticlaw;

alter table reaction_table drop column if exists kinetics_iddb;
alter table reaction_table add kinetics_iddb integer;

drop table if exists kinetic_law_parameters;
drop table if exists kinetic_law_functions;
drop table if exists kinetic_law_elements;
drop table if exists sbml_function_arguments;
drop table if exists sbml_unit_factor;
DROP SEQUENCE if exists sbml_unit_factor_iddb_seq;
drop table if exists sbml_kinetics;
DROP SEQUENCE if exists sbml_kinetics_iddb_seq;
drop table if exists sbml_function;
DROP SEQUENCE if exists sbml_function_iddb_seq;
drop table if exists model_parameters;
drop table if exists sbml_parameter;
DROP SEQUENCE if exists sbml_parameter_iddb_seq;
drop table if exists sbml_unit;
DROP SEQUENCE if exists sbml_unit_iddb_seq;

--definition of sbml unit

CREATE SEQUENCE sbml_unit_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_unit
(
  iddb integer NOT NULL DEFAULT nextval('sbml_unit_iddb_seq'::regclass),
  unitid  varchar(255),  
  name  varchar(255),
  model_iddb integer NOT NULL,
  
  CONSTRAINT sbml_unit_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_unit_model_fk FOREIGN KEY (model_iddb)
      REFERENCES public.model_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

--definition of sbml parameter
CREATE SEQUENCE sbml_parameter_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_parameter
(
  iddb integer NOT NULL DEFAULT nextval('sbml_parameter_iddb_seq'::regclass),
  parameterid  varchar(255),  
  name  varchar(255),
	value  numeric,
	units_iddb integer,
  
  CONSTRAINT sbml_parameter_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_parameter_units_fk FOREIGN KEY (units_iddb)
      REFERENCES public.sbml_unit (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);


--definition of many to many relation between model and sbml parameter
CREATE TABLE model_parameters
(
  model_id integer NOT NULL,
  parameter_id integer NOT NULL,  
  CONSTRAINT model_parameters_unique UNIQUE (model_id, parameter_id),
  CONSTRAINT model_parameters_model_fk FOREIGN KEY (model_id)
      REFERENCES public.model_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT model_parameters_parameter_fk FOREIGN KEY (parameter_id)
      REFERENCES public.sbml_parameter (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

--definition of sbml function
CREATE SEQUENCE sbml_function_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_function
(
  iddb integer NOT NULL DEFAULT nextval('sbml_function_iddb_seq'::regclass),
  functionid  varchar(255),  
  name  varchar(255),
  definition  text,
  model_iddb integer NOT NULL,
  
  CONSTRAINT sbml_function_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_function_model_fk FOREIGN KEY (model_iddb)
      REFERENCES public.model_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

--definition of sbml kinetics
CREATE SEQUENCE sbml_kinetics_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_kinetics
(
  iddb integer NOT NULL DEFAULT nextval('sbml_function_iddb_seq'::regclass),
  definition  text,
  
  CONSTRAINT sbml_kinetics_pk PRIMARY KEY (iddb)
);

ALTER TABLE reaction_table ADD FOREIGN KEY (kinetics_iddb) REFERENCES sbml_kinetics(iddb);


--definition of sbml kinetics
CREATE SEQUENCE sbml_unit_factor_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE sbml_unit_factor
(
  iddb integer NOT NULL DEFAULT nextval('sbml_unit_factor_iddb_seq'::regclass),
  unit_iddb  integer not null,
  exponent  integer not null default 1,
  scale  integer not null default 0,
  multiplier  numeric not null default 1.0,
  unittype varchar(255), 
  
  CONSTRAINT sbml_unit_factor_pk PRIMARY KEY (iddb),
  CONSTRAINT sbml_unit_factor_unit_fk FOREIGN KEY (unit_iddb)
      REFERENCES public.sbml_unit (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
  
);

CREATE TABLE sbml_function_arguments
(
  idx integer NOT NULL,
  sbml_function_iddb integer not null,
  argument_name varchar(255), 
  
  CONSTRAINT sbml_function_arguments_sbml_function_fk FOREIGN KEY (sbml_function_iddb)
      REFERENCES public.sbml_function (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
  
);

CREATE TABLE kinetic_law_parameters
(
  kinetic_law_id integer NOT NULL,
  parameter_id integer not null,
  
  CONSTRAINT kinetic_law_parameters_unique UNIQUE (kinetic_law_id, parameter_id),
  CONSTRAINT kinetic_law_parameters_sbml_kinetics_fk FOREIGN KEY (kinetic_law_id)
      REFERENCES public.sbml_kinetics (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT kinetic_law_parameters_parameter_fk FOREIGN KEY (parameter_id)
      REFERENCES public.sbml_parameter (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE kinetic_law_functions
(
  kinetic_law_id integer NOT NULL,
  function_id integer not null,
  
  CONSTRAINT kinetic_law_functions_unique UNIQUE (kinetic_law_id, function_id),
  CONSTRAINT kinetic_law_functions_sbml_kinetics_fk FOREIGN KEY (kinetic_law_id)
      REFERENCES public.sbml_kinetics (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT kinetic_law_functions_function_fk FOREIGN KEY (function_id)
      REFERENCES public.sbml_function (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE TABLE kinetic_law_elements
(
  kinetic_law_id integer NOT NULL,
  element_id integer not null,
  
  CONSTRAINT kinetic_law_elements_unique UNIQUE (kinetic_law_id, element_id),
  CONSTRAINT kinetic_law_elements_sbml_kinetics_fk FOREIGN KEY (kinetic_law_id)
      REFERENCES public.sbml_kinetics (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT kinetic_law_elements_element_fk FOREIGN KEY (element_id)
      REFERENCES public.element_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);



-- UPDATE 12.0.0~alpha.1/V12.0.0.20180311__order_of_data_overlays_added.sql

alter table layout add order_index integer default 0;
update layout l set order_index = (select count(*) from layout where iddb<l.iddb and creator_iddb=l.creator_iddb and l.model_iddb=model_iddb) +1;


-- UPDATE 12.0.0~beta.0/V12.0.0.20180314__create_structures_for_plugin_data.sql

CREATE SEQUENCE plugin_table_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE plugin_table
(
  iddb integer NOT NULL DEFAULT nextval('plugin_table_iddb_seq'::regclass),
  hash character varying(255) NOT NULL,
  name character varying(255) NOT NULL,
  version character varying(255) NOT NULL,
  CONSTRAINT plugin_pkey PRIMARY KEY (iddb),
  CONSTRAINT plugin_hash_unique UNIQUE (hash)
);

CREATE TABLE plugin_urls
(
  plugin_iddb integer NOT NULL,
  url character varying(1024) NOT NULL,
  CONSTRAINT plugin_urls_pkey PRIMARY KEY (plugin_iddb, url),
  CONSTRAINT plugin_urls_fk FOREIGN KEY (plugin_iddb)
      REFERENCES public.plugin_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);

CREATE SEQUENCE plugin_data_entry_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE TABLE plugin_data_entry
(
  iddb integer NOT NULL DEFAULT nextval('plugin_table_iddb_seq'::regclass),
  plugin_iddb integer NOT NULL,
  user_iddb integer,
  entry_key character varying(1024) NOT NULL,
  entry_value character varying(2048) NOT NULL,
  CONSTRAINT plugin_data_entry_pkey PRIMARY KEY (iddb),
  CONSTRAINT plugin_data_entry_plugin_fk FOREIGN KEY (plugin_iddb)
      REFERENCES public.plugin_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT plugin_data_entry_user_fk FOREIGN KEY (user_iddb)
      REFERENCES public.user_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
);


-- UPDATE 12.0.0~beta.1/V12.0.0.20180402__create_gui_preferences_table.sql

CREATE SEQUENCE user_gui_preferences_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE user_gui_preferences
(
  iddb integer NOT NULL DEFAULT nextval('user_gui_preferences_iddb_seq'::regclass),
  key character varying(255) NOT NULL,
  value character varying(255) NOT NULL,
  annotation_schema_iddb integer NOT NULL,
  CONSTRAINT user_gui_preferences_fk FOREIGN KEY (annotation_schema_iddb)
      REFERENCES public.user_annotation_schema_table (iddb) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE,
  CONSTRAINT user_gui_preferences_key_unique UNIQUE (key, annotation_schema_iddb)
);


-- UPDATE 12.0.0~beta.1/V12.0.0.20180405__add_table_for_reaction_stochiometry.sql

alter table node_table add column stoichiometry numeric(9,2) default null;


-- UPDATE 12.0.0~beta.2/V12.0.0.20180423__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.3/V12.0.0.20180410__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.3/V12.0.0.20180411__drop_data_mining_structures.sql

-- drop data mining structures
drop table datamining_references ;
drop table datamining_connections;
drop table datamining_table;
drop table data_mining_set_table ;
drop sequence datamining_table_iddb_seq;
drop sequence data_mining_set_iddb_seq;

-- change project status from int to string

alter table project_table add column status_string varchar(255) default 'UNKNOWN';
update project_table set status_string = 'PARSING_DATA' where status = 1;
update project_table set status_string = 'ANNOTATING' where status = 2;
update project_table set status_string = 'UPLOADING_TO_DB' where status = 3;
update project_table set status_string = 'EXTENDING_MODEL' where status = 4;
update project_table set status_string = 'GENERATING_IMAGES' where status = 5;
update project_table set status_string = 'CACHING' where status = 6;
update project_table set status_string = 'DONE' where status = 7;
update project_table set status_string = 'FAIL' where status = 8;
update project_table set status_string = 'CACHING_MIRIAM' where status = 9;
update project_table set status_string = 'VALIDATING_MIRIAM' where status = 10;
update project_table set status_string = 'REMOVING' where status = 11;
update project_table set status_string = 'CACHING_CHEMICAL' where status = 12;
update project_table set status_string = 'CACHING_DRUG' where status = 13;
update project_table set status_string = 'CACHING_MI_RNA' where status = 14;
alter table project_table drop column status ;
alter table project_table rename COLUMN status_string to status;

-- remove DATA MINING status
update project_table set status = 'UNKNOWN' where status = 'EXTENDING_MODEL';


-- UPDATE 12.0.0~beta.3/V12.0.0.20180427__add_field_to_determine_implementation_of_map_canvas.sql

-- alternative implementation of map canvas

alter table project_table add column google_map_license_accept_date timestamp without time zone;
alter table project_table add column map_canvas_type character varying default 'OPEN_LAYERS';


-- UPDATE 12.0.0~beta.3/V12.0.0.20180530__fix_LAYOUT_MANAGEMENT_for_new_API.sql

-- there is problem with privileges with new API
update privilege_table set privilege_class_type_db ='OBJECT_PRIVILEGE' where type = 'LAYOUT_MANAGEMENT';

-- UPDATE 12.0.0~beta.4/V12.0.0.20180607__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.5/V12.0.0.20180608__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.6/V12.0.0.20180628__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0~beta.7/V12.0.0.20180705__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.0/V12.0.0.20180716__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.1/V12.0.1.20180723__duplicates_in_reaction_ids_resolved.sql

-- issue #461 - duplicates in reaction ids resolved
update reaction_table r set  idreaction=concat(r.idreaction,'_',r.iddb) from (select idreaction, model_iddb from reaction_table group by idreaction, model_iddb having count(*)>1) t where r.idreaction=t.idreaction and r.model_iddb=t.model_iddb;


-- UPDATE 12.0.2/V12.0.2.20180731__duplicates_in_reaction_ids_resolved.sql

-- issue #461 - duplicates in reaction ids resolved
update reaction_table r set  idreaction=concat(r.idreaction,'_',r.iddb) from (select idreaction, model_iddb from reaction_table group by idreaction, model_iddb having count(*)>1) t where r.idreaction=t.idreaction and r.model_iddb=t.model_iddb;


-- UPDATE 12.0.3/V12.0.3.20180827__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo


-- UPDATE 12.0.4/V12.0.4.20180830__empty_file_to_force_directory_to_be_commited_to_git_repo.sql

-- empty file to force directory to be commited to git repo
